.DEVICE ATMEGA16

.CSEG        jmp START
             jmp INT0
             jmp INT1
             jmp T2_COMP
             jmp T2_OVF
             jmp T1_CAPT
             jmp T1_COMPA
             jmp T1_COMPB
             jmp T1_OVF
             jmp T0_OVF
             jmp SPI_STC
             jmp USR_RXC
             jmp USR_UDR
             jmp USR_TXC
             jmp ADC_END
             jmp EE_RDY
             jmp ANA_COMP
             jmp TWI
             jmp INT2
             jmp T0_COMP
             jmp SPM_RDY

TAB_ANOD:	.DB $0f,$01,$02,$04,$08
TAB_KATOD:  .DB $3f,$06,$5b,$4f,$66,$6d,$7d,$07,$7f,$6f,$00

.DSEG

STR_OUT:    .BYTE 4
DECIMAL:    .BYTE 4
TCN_VAL:    .BYTE 2

.CSEG

START:      cli
;----------------------------------
            ldi r16,$5f
            out $3d,r16
            ldi r16,$04
            out $3e,r16
;---------------------------------
            ldi r16,0b11111111
            out $17,r16 ;DDRB
            ldi r16,0b00001111
            out $11,r16 ;DDRD
;--------------------------------
            ldi r16,0b00000011
            out $33,r16         ;TCCR0, CLK/32

            ldi r16,0b01000001  ;TCCR1B, CLK,   
            out $2e,r16
;----------------------------
            ldi r16,0b00100001  ; T0,  T1
            out $39,r16         ;TIMSK
;--------------------------------------
MAIN:       clr r15 ; adc
            clr r25
            sei
WAIT:       rjmp WAIT
            

INT0:       reti
INT1:       reti
T2_COMP:    reti
T2_OVF:     reti

T1_CAPT:    push r16
            in r16,$3f
            push r16
            push r19
            push r20
            push r21
            push r22
            push r23
            push r24
            push r30
            push r31
            in r20,$26  ;   
            in r21,$27
            mov r22,r20
            mov r23,r21
            ldi r30,low(TCN_VAL)
            ldi r31,high(TCN_VAL)
            ld r16,Z+
            sub r20,r16 ;    
            ld r16,Z+   ; r20, r21-  
            sbc r21,r16
            st -Z,r23   ;     TCN_VAL
            st -Z,r22
;---------------BIN_DEC----------------
            ldi r19,4
            clr r22
            ldi r30,low(DECIMAL+4)
            ldi r31,high(DECIMAL+4)
            ldi r24,$e8
            ldi r23,$03
            rjmp LOOP1
MUL100:     ldi r24,$64
            ldi r23,$00
            rjmp LOOP1
MUL10:      ldi r24,$0a
            ldi r23,$00
LOOP1:      sub r20,r24
            sbc r21,r23
            brlo BACK
            inc r22
            rjmp LOOP1
BACK:       add r20,r24
            adc r21,r23
            st -Z,r22
            clr r22
            dec r19
            cpi r19,3
            breq MUL100
            cpi r19,2
            breq MUL10
            st -Z,r20
;--------------------------------------
            pop r31
            pop r30
            pop r24
            pop r23
            pop r22
            pop r21
            pop r20
            pop r19
            pop r16
            out $3f,r16      ;
            pop r16
            reti
T1_COMPA:   reti
T1_COMPB:   reti
T1_OVF:     reti

;-----------------LED------------------
T0_OVF:     push r16
            in r16,$3f
            push r16
            push r18
            push r19
            push r20
            push r26
            push r27
            push r28
            push r29
            push r30
            push r31

            ldi r30,low(STR_OUT)
            ldi r31,high(STR_OUT)
            add r30,r25
            adc r31,r15
            ld r18,Z
            ldi r30,low(TAB_ANOD*2)
            ldi r31,high(TAB_ANOD*2)
            lpm r0,Z+
            com r0
            mov r20,r0
            in r16,$12
            and r16,r20
            out $12,r16
            add r30,r25
            adc r31,r15
            lpm r0,Z
            mov r19,r0
            mov r16,r18
            ldi r30,low(TAB_KATOD*2)
            ldi r31,high(TAB_KATOD*2)
            add r30,r16
            adc r31,r15
            lpm r0,Z
            mov r20,r0
            com r20
            out $18,r20
            in r16,$12
            or r16,r19
            out $12,r16
            inc r25
            cpi r25,4
            brne BR1
            ldi r25,0
            ldi r16,4
            ldi r26,low(STR_OUT)
            ldi r27,high(STR_OUT)
            ldi r28,low(DECIMAL)
            ldi r29,high(DECIMAL)
LOOP2:      ld r20,Y+
            st X+,r20
            dec r16
            brne LOOP2
BR1:        pop r31
            pop r30
            pop r29
            pop r28
            pop r27
            pop r26
            pop r20
            pop r19
            pop r18
            pop r16
            out $3f,r16
            pop r16
;--------------------------------------

            reti
SPI_STC:    reti
USR_RXC:    reti
USR_UDR:    reti
USR_TXC:    reti
ADC_END:    reti
EE_RDY:     reti
ANA_COMP:   reti
TWI:        reti
INT2:       reti
T0_COMP:    reti
SPM_RDY:    reti



            
            
            
            
            
            
